﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.DragDrop;

namespace DragAndDrop
{
    public partial class MainPage : UserControl
    {
        ObservableCollection<Picture> data;
        ObservableCollection<Picture> otherdata ;
        public MainPage()
        {
            InitializeComponent();

            data = new ObservableCollection<Picture>();
            for (int i = 0; i < 5; i++)
            {
                data.Add(new Picture("Image/Folder.png", i.ToString()));
            }
            lstbox.ItemsSource = data;


            otherdata = new ObservableCollection<Picture>();
            for (int j = 6; j < 8; j++) 
            {
                otherdata.Add(new Picture("Image/Folder.png", j.ToString()));
            }
            otherlstbox.ItemsSource = otherdata;
            RadDragAndDropManager.AddDragQueryHandler(this, OnDragQuery);
            RadDragAndDropManager.AddDragInfoHandler(this, OnDragInfo);

            RadDragAndDropManager.AddDropQueryHandler(this, OnDropQuery);
            RadDragAndDropManager.AddDropInfoHandler(this, OnDropInfo);

        }

        #region /*拖放操作*/
        Brush listBoxDragPossible = new SolidColorBrush(Colors.Orange);
        private void OnDragInfo(object sender, DragDropEventArgs e)
        {
            System.Windows.Controls.ListBoxItem listBoxItem = e.Options.Source as System.Windows.Controls.ListBoxItem;
            System.Windows.Controls.ListBox box = System.Windows.Controls.ItemsControl.ItemsControlFromItemContainer(listBoxItem) as System.Windows.Controls.ListBox;
            IList<Picture> itemsSource = box.ItemsSource as IList<Picture>;
            Picture payload = e.Options.Payload as Picture;
            if (e.Options.Status == DragStatus.DragComplete)
            {
                if (payload != null && itemsSource.Contains(payload))
                {
                    itemsSource.Remove(payload);
                }
            }

        }

        private void OnDragQuery(object sender, DragDropQueryEventArgs e)
        {
            System.Windows.Controls.ListBoxItem listBoxItem = e.Options.Source as System.Windows.Controls.ListBoxItem;
            System.Windows.Controls.ListBox box = System.Windows.Controls.ItemsControl.ItemsControlFromItemContainer(listBoxItem) as System.Windows.Controls.ListBox;
            if (e.Options.Status == DragStatus.DragQuery && box != null)
            {
                e.Options.Payload = box.SelectedItem;
                ContentControl cue = new ContentControl();
                cue.ContentTemplate = this.Resources["ApplicationDragTemplate"] as DataTemplate;
                cue.Content = box.SelectedItem;
                e.Options.DragCue = cue;
                e.Options.ArrowCue = RadDragAndDropManager.GenerateArrowCue();
            }
            e.QueryResult = true;
        }
        // OnDropQuery event handler
        private void OnDropQuery(object sender, DragDropQueryEventArgs e)
        {
            System.Windows.Controls.ItemsControl box = e.Options.Destination as System.Windows.Controls.ItemsControl;
            IList<Picture> itemsSource = box.ItemsSource as IList<Picture>;
            Picture payload = e.Options.Payload as Picture;
            e.QueryResult = payload != null && !itemsSource.Contains(payload);


        }
        private void OnDropInfo(object sender, DragDropEventArgs e)
        {
            System.Windows.Controls.ItemsControl box = e.Options.Destination as System.Windows.Controls.ItemsControl;
            IList<Picture> itemsSource = box.ItemsSource as IList<Picture>;
            Picture payload = e.Options.Payload as Picture;
            if (e.Options.Status == DragStatus.DropPossible)
            {
                box.BorderBrush = listBoxDragPossible;
            }
            else
            {
                box.BorderBrush = new SolidColorBrush(Colors.Gray);
            }

            if (e.Options.Status == DragStatus.DropComplete)
            {
                if (!itemsSource.Contains(payload))
                {
                    itemsSource.Add(payload);
                }
            }

        }

        #endregion
    }
}
